<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::queue_kernel_2&lt; T, block_size, mem_manager &gt;::node Struct Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1queue__kernel__2.html">queue_kernel_2</a></li><li class="navelem"><a class="el" href="structdlib_1_1queue__kernel__2_1_1node.html">node</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="structdlib_1_1queue__kernel__2_1_1node-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::queue_kernel_2&lt; T, block_size, mem_manager &gt;::node Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:aab63fced1abe55e15a126854fcbbef7b"><td class="memItemLeft" align="right" valign="top"><a id="aab63fced1abe55e15a126854fcbbef7b"></a>
<a class="el" href="structdlib_1_1queue__kernel__2_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>next</b></td></tr>
<tr class="separator:aab63fced1abe55e15a126854fcbbef7b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a51942d71631a66ca5bc62c2bb9127f1c"><td class="memItemLeft" align="right" valign="top"><a id="a51942d71631a66ca5bc62c2bb9127f1c"></a>
T&#160;</td><td class="memItemRight" valign="bottom"><b>item</b> [block_size]</td></tr>
<tr class="separator:a51942d71631a66ca5bc62c2bb9127f1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename T, unsigned long block_size, typename mem_manager = default_memory_manager&gt;<br />
struct dlib::queue_kernel_2&lt; T, block_size, mem_manager &gt;::node</h3>

<pre class="fragment">REQUIREMENTS ON block_size
    0 &lt; block_size &lt; 2000000000

INITIAL VALUE
    queue_size == 0   
    current_element == 0
    at_start_ == true

CONVENTION
    queue_size == the number of elements in the queue
    at_start() == at_start_
    current_element_valid() == (current_element != 0)
    if (current_element_valid()) then
        element() == current_element-&gt;item[current_element_pos]

    if (queue_size &gt; 0)                
    {                    
        in-&gt;item[in_pos] == the spot where we will put the next item added
                            into the queue
        out-&gt;item[out_pos] == current()

        when enqueuing elements inside each node item[0] is filled first, then 
        item[1], then item[2], etc.


        each node points to the node inserted after it except for the most 
        recently inserted node.  
    }
</pre><p>! </p>
</div><hr/>The documentation for this struct was generated from the following file:<ul>
<li><a class="el" href="queue__kernel__2_8h_source.html">queue_kernel_2.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
